// SADodgeRoll v1 Mod by Nebucha
///<reference path='.config/sa.d.ts' />

var player = new Player(0);
var is_dodging = false;
var end_crouch = false;
var start_crouch = false;

while (true) {
    wait(0);
    // Input is aim and sprint. Will not activate while ducking or already in the middle of a dodge roll.
    if (!is_dodging && player.isControlOn() && !player.getChar().isInAnyCar() && ((Widget.IsPressed(19) && Widget.IsPressed(31)))) {
        // Only perform move if player is moving.
        var player_input = Pad.GetPositionOfAnalogueSticks(0);
        if (player_input.leftStickX != 0 || player_input.leftStickY != 0) {
            // Do not allow a second dodge in the middle of a first dodge.
            is_dodging = true;
            // Set alternate style of roll if started from a crouch.
            if (player.getChar().isDucking()) {
                start_crouch = true;
                player.getChar().clearTasks();
            }
            else {
                player.getChar().clearTasksImmediately();
            }
            wait(0);
            // Animation is spliced from EV_Dive (evasive dive from approaching car) and getup (getting up from your back).
            Task.PlayAnimNonInterruptable(player.getChar(), "EV_Dive", "PED", 4.0, 0, 1, 1, 0, 375);
            wait(0);
            player.getChar().setAnimSpeed("EV_Dive", 1.5);
            player.getChar().setAnimCurrentTime("EV_Dive", 0.2);
            TIMERA = 0;
            // Updates the character's heading every few frames to match the player's input. Allows for moving during animation.
            while (TIMERA < 325) {
                player.getChar().setHeading(getInputHeadingRelativeToCamera());
                wait(25);
                // If player hits crouch button mid-animation, end in a crouch.
                if (getCrouchInput()) {
                    end_crouch = true;
                }
            }
            TIMERA = 0
            // Adjust for animation turning character slightly left.
            while (TIMERA < 50) {
                player.getChar().setHeading(getInputHeadingRelativeToCamera() - 5);
                wait(25);
                if (getCrouchInput()) {
                    end_crouch = true;
                }
            }
            Task.PlayAnim(player.getChar(), "getup", "PED", 4.0, 0, 1, 1, 0, 195);
            wait(0);
            player.getChar().setAnimSpeed("getup", 1.8);
            player.getChar().setAnimCurrentTime("getup", 0.15);
            TIMERA = 0;
            while (TIMERA < 45) {
                player.getChar().setHeading(getInputHeadingRelativeToCamera() - 10);
                wait(15);
                if (getCrouchInput()) {
                    end_crouch = true;
                }
            }
            TIMERA = 0;
            while (TIMERA < 30) {
                player.getChar().setHeading(getInputHeadingRelativeToCamera() - 5);
                wait(15);
                if (getCrouchInput()) {
                    end_crouch = true;
                }
            }
            // Skip forward in animation to avoid losing momentum.
            player.getChar().setAnimCurrentTime("getup", 0.4);
            while (TIMERA < 120) {
                player.getChar().setHeading(getInputHeadingRelativeToCamera());
                wait(15);
                // Prematurely ends getup animation and switches to crouch animation if crouch button is pressed during move or is a crouch roll.
                if (getCrouchInput() || end_crouch || start_crouch) {
                    //                    player.getChar().clearTasks();
                    //                    wait(0);
                    Task.ToggleDuck(player.getChar(), true);
                    wait(120 - TIMERA);
                    break;
                }
            }
            // Clear tasks at the end (unless crouching) to avoid animation issues, then reset variables.
            if (!end_crouch && !start_crouch) {
                player.getChar().clearTasks();
                wait(0);
            }
            start_crouch = false;
            end_crouch = false;
            is_dodging = false;
        }
    }
}

// Calculate heading determined by player's input relative to camera's perspective in the world. 
// Better than using simple player heading, this function allows for adjusting movement mid-animation based on player input.
// Example: if player camera is facing South and player pulls analog stick down to go backwards, this function will return North since that's where analog stick is moving.

function getInputHeadingRelativeToCamera() {
    player_input = Pad.GetPositionOfAnalogueSticks(0);
    camera_heading = Math.GetHeadingFromVector2D(Camera.GetActivePointAt().x - Camera.GetActiveCoordinates().x, Camera.GetActivePointAt().y - Camera.GetActiveCoordinates().y);
    input_heading = Math.GetHeadingFromVector2D(-player_input.leftStickX, player_input.leftStickY);
    return (camera_heading + input_heading + 180) % 360;
}

// Get correct crouch input for gamepad or keyboard.

function getCrouchInput() {
    return (Widget.IsPressed(7) && !Pad.IsKeyPressed(72)) || Pad.IsKeyPressed(67);
}